package com.malk.pro.aspect;


import com.malk.core.McProject;
import lombok.extern.slf4j.Slf4j;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.slf4j.MDC;
import org.springframework.stereotype.Component;


/***
 * controller 切面 用于注入宜搭参数
 */
@Aspect
@Component
@Slf4j
public class ControllerYdAspect {

    // demo ===============================谷元/能辉========================================================================== start
    // 定义切点：拦截所有Controller包下的方法
    @Pointcut("execution(* com.malk.pro.guyuan.controller..*.*(..))")
    public void guyuanControllerPointcut() {}
    // 在方法执行前执行
    @Before("guyuanControllerPointcut()")
    public void guyuanBefore(JoinPoint joinPoint) {
        // 项目编号 2001 每个项目一个编号，请勿重复
        McProject.addYida("2001",new String[]{"APP_FKRK7Y94DPI1S9DV1605","FN7666A1ZD0STZZ75W4CKD1GD07X3PUW2FBRKT"});
        MDC.put("MDC_KEY_PID","2001");
    }
    // 在方法执行后执行
    @AfterReturning(pointcut = "guyuanControllerPointcut()", returning = "result")
    public void guyuanAfterReturning(JoinPoint joinPoint, Object result) {
        MDC.remove("MDC_KEY_PID");
    }
    // demo ===============================谷元/能辉========================================================================== end


    // ===============================职业技能========================================================================== start
    // 定义切点：拦截所有Controller包下的方法
    @Pointcut("execution(* com.malk.pro.zyjn.controller..*.*(..))")
    public void zyjnControllerPointcut() {}
    // 在方法执行前执行
    @Before("zyjnControllerPointcut()")
    public void zyjnBefore(JoinPoint joinPoint) {
        // 项目编号 2002 每个项目一个编号，请勿重复
        McProject.addYida("2002",new String[]{"APP_GKH227Q9PDQ2CYIIJSHJ","I5D66NB1S3JNGJBDEND4L78FN8CT34LMQVKZLRP"});
        McProject.addDd("2002",new String[]{"dingn2nkwrrosmyjk9o2","t26NJ2TIHeQZAG17QPJAPoVgrVwPUZCLH0JLO955_c0BoAhdaAS5eNf9Fc6KAepo"});
        MDC.put("MDC_KEY_PID","2002");
    }
    // 在方法执行后执行
    @AfterReturning(pointcut = "zyjnControllerPointcut()", returning = "result")
    public void zyjnAfterReturning(JoinPoint joinPoint, Object result) {
        MDC.remove("MDC_KEY_PID");
    }
    // ===============================职业技能========================================================================== end


}
